/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package bachelorprojectstock;


import java.sql.Timestamp;
import java.time.LocalDateTime;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQuery;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 *
 * @author marti
 */
@Entity
@Data
@AllArgsConstructor
@NoArgsConstructor
@NamedQuery(name = "Stock.findAllStocks",
        query = "select s from Stock s order by s.tag")
@NamedQuery(name = "Stock.findByName",
        query = "select s from Stock s where s.name = :stockName")

@NamedQuery(name = "Stock.findByTag",
        query = "select s from Stock s where s.tag = :stockTag")
public class Stock {
    @Id
    String stockId;
    
    String tag;
    String name;
    String market;
    String type = "Default";
    
    //Updated everytime this stock is re-entered into the system
    //So when it is not, it will be deleted based on its old time
    LocalDateTime lastChecked = LocalDateTime.now();
    
    
    public Stock(String stockId, String tag, String name, String market){
        this.stockId = stockId;
        this.tag = tag;
        this.name = name;
        this.market = market;
    }
}
