const urlR = 'http://158.38.101.196:9000/BachelorTestOne-1.0/api/log/getlogentries';
const urlN = "http://158.38.101.196:9000/BachelorTestOne-1.0/api/stock/getstock";
let response = []
let nameResponse = []
let combo_list = [];
let win_rate_data = []
let saleList = []
let saleListWithNames = []
let pnl_data = []
let pnlx = []
let pnly = []
let tag_data = [];
let tag_names = []
let stock_data = [];
let stock_names = []
let tag_trades = [];
let best_combo_data = [];
let worst_combo_data = [];
let timesRun = 0;

const tag_selector = document.getElementById("tag_selector");
const worst_combo_table = document.getElementById("worst_combo_table");
const best_combo_table = document.getElementById("best_combo_table");
const tag_trade_table = document.getElementById("tag_trade_table");
const win_rate_layout = {width: 400, height: 300, margin: {t: 0, b: 0}};
const pnl_layout = {
    title: 'PNL evolution',
    hovermode: 'x unified',
    xaxis: {
        'showgrid': false
    },
    yaxis: {
        'showgrid': false
    }
};


function getResponse() {
    const Http = new XMLHttpRequest();
    Http.open("GET", urlR);
    Http.setRequestHeader("Content-Type", "application/json;charset=UTF-8")
    Http.setRequestHeader("Authorization", "Bearer " + localStorage.getItem("key"));
    Http.send()
    response;
    Http.onreadystatechange = (event) => {
        sResponse = JSON.parse(Http.responseText);
        response = sResponse;
        getSaleList()
        //getStockNames()
        getPnlXY()
        setValues()
        displayData()
    }
}

function getNameResponse(listOfNames) {
    const Http = new XMLHttpRequest();
    Http.open("GET", urlN);
    Http.setRequestHeader("Content-Type", "application/json;charset=UTF-8")
    Http.setRequestHeader("Authorization", "Bearer " + localStorage.getItem("key"));
    Http.send(listOfNames)
    Http.onreadystatechange = (event) => {
        nameResponse = JSON.parse(Http.responseText);
    }
}

function setValues() {
    win_rate_data = []
    pnl_data = []
    tag_names = []
    stock_names = []
    stock_data = []
    tag_data = []
    win_rate_data = [{
        domain: {x: [0, 1], y: [0, 1]},
        value: getWinRate(),
        number: {suffix: "%"},
        title: {text: "Win rate"},
        type: "indicator",
        mode: "gauge+number",
        gauge: {
            axis: {range: [0, 100]},
            bar: {color: "black"},
            steps: [
                {range: [0, 50], color: "#ff8080"},
                {range: [50, 100], color: "lightgreen"}
            ],
        }
    }];
    pnl_data = [
        {
            x: pnlx,
            y: pnly,
            type: 'scatter',
            showlegend: false,
            line: {shape: 'spline'},
            hovertemplate: 'PNL: %{y} NOK'
        }
    ];
    tag_names = getListOfTags()
    stock_names = getStockNamesList(saleList)
    for (let i = 0; i < stock_names.length; i++) {
        stock_data.push(getStockNameData(stock_names[i]))
    }
// Sort the array by the mean value, in descending order
    stock_data.sort((first_elem, second_elem) => second_elem.avg - first_elem.avg)
    for (let i = 0; i < stock_names.length; ++i) {
        stock_data[i].name = stock_names[i];
    }
    for (let i = 0; i < tag_names.length; ++i) {
        tag_data.push(getTagData(tag_names[i]))
    }
// Sort the array by the mean value, in descending order
    tag_data.sort((first_elem, second_elem) => second_elem.avg - first_elem.avg)
    for (let i = 0; i < tag_names.length; ++i) {
        tag_data[i].name = tag_names[i];
    }

// Show tags in the selectbox
    if (timesRun == 0) {
        tag_names.forEach(tag_name => {
            const option = document.createElement("option");
            option.innerText = tag_name;
            tag_selector.appendChild(option);
        });
        timesRun ++;
    }
}


function getSaleList() {
    saleList = []
    for (let i = 0; i < response.length; i++) {
        if (response[i].transaksjonsType == "SALG") {
            saleList.push(response[i])
        }
    }
}


function getStockNames() {
    saleListWithNames = []
    let listOfStocksToGet = []
    i = 0
    while (i < saleList.length) {
        if (listOfStocksToGet.includes(saleList[i].verdiPapir) == false) {
            listOfStocksToGet.push(saleList[i].verdiPapir)
        }
        i++
    }
    getNameResponse(listOfStocksToGet)
    for (let y = 0; y < saleList.length; y++) {
        x = 0
        while (x < nameResponse.length) {
            if (saleList[y].verdiPapir.toLowerCase() == nameResponse[x].tag.toLowerCase()) {
                saleListWithNames.push({
                    verdiPapir: saleList[y].verdiPapir,
                    handelsDag: saleList[y].handelsDag,
                    belop: saleList[y].belop,
                    resultat: saleList[y].resultat,
                    tags: saleList[y].tags,
                    stock_name: nameResponse[x].name
                })
            }
            x++
        }
    }
}

/////////////////////////////////////////
// Win-rate data and layout
/////////////////////////////////////////
function getWinRate() {
    let winner = 0
    let result = 0
    for (let i = 0; i < saleList.length; i++) {
        if (saleList[i].resultat > 0) {
            winner++
        }
    }
    result = winner / saleList.length * 100
    return result
}


/////////////////////////////////////////
// PNL chart data and layout
/////////////////////////////////////////


function getPnlXY() {
    pnlx = []
    pnly = []
    for (let i = 0; i < saleList.length; i++) {
        let date = saleList[i].handelsDag.split("T")
        pnlx.push(date[0])
        pnly.push(saleList[i].resultat)
    }
}


/////////////////////////////////////////
// Tag chart data
/////////////////////////////////////////
function getTagData(tag) {
    let total = 0
    i = 0
    let total_cost = 0
    let total_profit = 0
    let avg = 0;
    let trades = []
    for (i; i < saleList.length; i++) {
        if (saleList[i].tags.includes(tag)) {
            total += saleList[i].resultat
            trades.push(saleList[i].resultat)
            total_cost += parseFloat(saleList[i].belop)
            total_profit += parseFloat(saleList[i].resultat)
        }
    }
    avgp = (total_profit / total_cost) * 100
    let number = i + 1
    let average = total / number
    return {y: trades, type: 'box', avg: average, showlegend: false, avgp: avgp}
}


/////////////////////////////////////////
// Stock chart data
/////////////////////////////////////////
function getStockNameData(name) {
    let total
    i = 0
    let trades = []
    for (i; i < saleList.length; i++) {
        if (saleList[i].verdiPapir.includes(name)) {
            total += saleList[i].resultat
            trades.push(saleList[i].resultat)
        }
    }
    let number = i + 1
    let average = total / number
    return {y: trades, type: 'box', avg: average, showlegend: false}
}

function getStockNamesList(saleList) {
    //let stockList = saleList
    let nameList = []
    for (let i = 0; i < saleList.length; i++) {
        if (nameList.includes(saleList[i].verdiPapir) == false) {
            nameList.push(saleList[i].verdiPapir)
        }
    }
    return nameList
}


/////////////////////////////////////////
// Tag combo data
/////////////////////////////////////////

function getNrOfTagsUsed() {
    let count = {}
    let str = []
    response.map(function (barr, i) {
        barr.tags.map(function (tag, k) {
            count[tag] = (+count[tag] || 0) + 1

        });
    });
    for (tag in count) {
        str.push({label: tag, y: count[tag]})
    }
}

function getListOfTags() {
    let count = {}
    let str = []
    response.map(function (barr, i) {
        barr.tags.map(function (tag, k) {
            count[tag] = (+count[tag] || 0) + 1
        });
    });
    for (tag in count) {
        str.push(tag)
    }

    return str;
}

function getTagCombination() {
    let combo_tag_list = []
    for (let i = 0; i < saleList.length; i++) {
        if (saleList[i].tags.length == 1) {

        } else if (saleList[i].tags.length == 2) {
            let PnL = (saleList[i].resultat / saleList[i].belop) * 100
            combo_tag_list.push({tag1: saleList[i].tags[0], tag2: saleList[i].tags[1], pnl: PnL})
        } else {
            let PnL = (saleList[i].resultat / saleList[i].belop) * 100
            combo_tag_list.push({tag1: saleList[i].tags[0], tag2: saleList[i].tags[1], pnl: PnL})
            combo_tag_list.push({tag1: saleList[i].tags[0], tag2: saleList[i].tags[2], pnl: PnL})
            combo_tag_list.push({tag1: saleList[i].tags[1], tag2: saleList[i].tags[2], pnl: PnL})
        }
    }
    return combo_tag_list;
}

function countCombinations(tag) {
    let combinationlist = getTagCombination();
    let combinedCombinationList = [];
    for (let i = 0; i < combinationlist.length; i++) {
        if (combinationlist[i].tag1 == tag) {
            combinedCombinationList.push({tag: combinationlist[i].tag2, nroftrades: 1, pnl: combinationlist[i].pnl})
        } else if (combinationlist[i].tag2 == tag) {
            combinedCombinationList.push({tag: combinationlist[i].tag1, nroftrades: 1, pnl: combinationlist[i].pnl})
        }
    }

    let result = Object.values(combinedCombinationList.reduce((c, {tag, nroftrades, pnl}) => {
        c[tag] = c[tag] || {tag, nroftrades: [], pnl: []};
        c[tag].nroftrades = c[tag].nroftrades.concat(Array.isArray(nroftrades) ? nroftrades : [nroftrades])
        c[tag].pnl = c[tag].pnl.concat(Array.isArray(pnl) ? pnl : [pnl]);
        return c;
    }, {}))

    for (let i = 0; i < result.length; i++) {
        let reducer = (accumulator, currentValue) => accumulator + currentValue
        result[i].nroftrades = result[i].nroftrades.reduce(reducer)
        result[i].pnl = result[i].pnl.reduce(reducer)
    }
    return result;
}

function getTradesByTag(tag) {
    let tagTrades = []
    for (let i = 0; i < saleList.length; i++) {
        if (saleList[i].tags.includes(tag)) {
            let PnL = (saleList[i].resultat / saleList[i].belop) * 100
            let date = saleList[i].handelsDag.split("T")
            tagTrades.push({
                stock_name: saleList[i].stock_name,
                stock_symbol: saleList[i].verdiPapir,
                pnl: PnL,
                date: date[0]
            })
        }
    }
    tag_trades = tagTrades
}

function getBestCombo(tag) {
    let best_combinations = [];
    let combinations = countCombinations(tag);
    combinations.sort(function (a, b) {
        return b.pnl - a.pnl
    })
    i = 0;
    while (i < 5 && i < combinations.length) {
        best_combinations.push(combinations[i])
        i++
    }
    best_combo_data = best_combinations;
}

function getWorstCombo(tag) {
    let worst_combinations = [];
    let combinations = countCombinations(tag);
    combinations.sort(function (a, b) {
        return a.pnl - b.pnl
    })
    i = 0;
    while (i < 5 && i < combinations.length) {
        worst_combinations.push(combinations[i])
        i++
    }
    worst_combo_data = worst_combinations;
}

// Display all the data
function displayData() {
    showCharts();
    showTagDetailTable();
    showTagCombos(best_combo_data, best_combo_table);
    showTagCombos(worst_combo_data, worst_combo_table);
    showSingleTagAnalysis(tag_names[0])
}

// Show all charts
function showCharts() {
    Plotly.newPlot('pnl_chart', pnl_data, pnl_layout);
    Plotly.newPlot('tag_overview_chart', tag_data);
    Plotly.newPlot('stock_overview_chart', stock_data);
    document.getElementById("tag_overview_chart").on("plotly_click", function (event) {
        if (event && event.points && event.points.length >= 1) {
            const tag_name = event.points[0].x;
            showSingleTagAnalysis(tag_name);
        }
    })
    Plotly.newPlot('win_rate_chart', win_rate_data, win_rate_layout);
}

// Show analysis page for a single tag
function showSingleTagAnalysis(tag_name) {
    getTradesByTag(tag_name)
    showTagDetailTable()
    getBestCombo(tag_name)
    showTagCombos(best_combo_data, best_combo_table)
    getWorstCombo(tag_name)
    showTagCombos(worst_combo_data, worst_combo_table)
    const tag_index = tag_names.indexOf(tag_name);
    if (tag_index >= 0) {
        tag_selector.selectedIndex = tag_index;
    }
    const avg_pnl = Math.round(getTagData(tag_name).avgp);
    document.getElementById("tag_avg_pnl").innerText = avg_pnl + "%";
    showTagNames(tag_name);
    document.getElementById("single-tag-analysis").scrollIntoView();
}

// Sets tag name in all elements with a specific class
function showTagNames(tag_name) {
    const elems = document.getElementsByClassName("current_tag_name");
    for (let i = 0; i < elems.length; ++i) {
        elems[i].innerText = `"${tag_name}" tag.`
    }
}

// Show a table with details for a single tag
function showTagDetailTable() {
    // Clear previous data
    const tbody = tag_trade_table.querySelector("tbody");
    tbody.innerHTML = "";

    // Create a row for every tag-based trade
    tag_trades.forEach(trade => {
        const row = document.createElement("tr");
        const pnl = createPnlBar(Math.round(trade.pnl));
        row.innerHTML = `<td>${trade.date}</td>`
            + `<td> ${trade.stock_symbol}</td>`
            + `<td>${pnl}</td>`;
        tbody.appendChild(row);
    });
}

// Return a string the contains content for PNL cell in the tag deal table - a div with appropriate color and width, and the text
function createPnlBar(pnl) {
    const color = pnl > 0 ? "green" : "red";
    const pnl_text = `<div style="color: ${color}" class="pnl-text">${pnl}%</div>`;
    let width = Math.abs(pnl) * 3; // Width of the bar depends on the profit
    if (width > 280) {
        width = 280
    } else if (width < -280) {
        width = -280
    }
    const bar = `<div style="width: ${width}px; background-color: ${color}; " class="pnl-block"></div>`;
    let positive_bar = "";
    let negative_bar = "";
    if (pnl > 0) {
        positive_bar = bar;
    } else {
        negative_bar = bar;
    }
    return `<div class="tag-pnl-container"><div>${negative_bar}</div>${pnl_text}<div>${positive_bar}</div></div>`;
}

function showTagCombos(combo_data, combo_table) {
    // Clear previous data
    const tbody = combo_table.querySelector("tbody");
    tbody.innerHTML = "";
    combo_data.forEach(combo_data => {
        const row = document.createElement("tr");
        const pnl = createPnlBar(Math.round(combo_data.pnl));
        row.innerHTML = `<td>${combo_data.tag}</td>`
            + `<td>${combo_data.nroftrades}</td>`
            + `<td>${pnl}</td>`;
        tbody.appendChild(row);
    });
}
