

const urlS='http://158.38.101.196:9000/BachelorTestOne-1.0/api/log/createwjson';
const urlR='http://158.38.101.196:9000/BachelorTestOne-1.0/api/log/getlogentries';
const urlU='http://158.38.101.196:9000/BachelorTestOne-1.0/api/log/editcomment';
const urlT='http://158.38.101.196:9000/BachelorTestOne-1.0/api/log/addtag'

updateList();

let selectedFile

//source for converting the files to JSON: https://levelup.gitconnected.com/how-to-convert-excel-file-into-json-object-by-using-javascript-9e95532d47c5
document.getElementById('input').addEventListener("change",(event)=>{
    
    selectedFile = event.target.files[0];
})

document.getElementById('uploadButton').addEventListener("click",(event)=>{
    const Http = new XMLHttpRequest();
    
    if(selectedFile){
        let fileReader = new FileReader();
        fileReader.readAsBinaryString(selectedFile);
        fileReader.onload = (event)=>{
           
            let data = event.target.result;
            data = data.replace(/,/g,'.')
            let workbook = XLSX.read(data,{type:'binary', cellDates:true, cellNF: false, cellText:false, raw:true});

            


           
            Http.open("POST", urlS);
            Http.setRequestHeader("Content-Type", "application/json;charset=UTF-8")
            Http.setRequestHeader("Authorization", "Bearer " + localStorage.getItem("key"));
            workbook.SheetNames.forEach(sheet =>{
                let rowObject = XLSX.utils.sheet_to_row_object_array(workbook.Sheets[sheet]);
                
                
                Http.send(JSON.stringify(rowObject));

                Http.onreadystatechange = (e) => {
                
                    updateList();
                }

            })
        }
    }
});
//has to be var to work
var response
function updateList(){
    const Http = new XMLHttpRequest();
    Http.open("GET",urlR);
    Http.setRequestHeader("Content-Type", "application/json;charset=UTF-8")
    Http.setRequestHeader("Authorization", "Bearer " + localStorage.getItem("key"));
    Http.send()
    response;
    Http.onreadystatechange = (event)=>{
        response = JSON.parse(Http.responseText);
        createList(response);
    }
}



function createList(response){
    $(document).ready(function(){
        $('select').chosen({ width:'400px'});
        $(".chosen-select").chosen({rtl: true});
    });
    table.innerHTML = '';
for(let i =0;i<response.length;i++){
    
    let row = `<tr>
                        <td>${response[i].id}</td>
                        <td>${response[i].handelsDag}</td>
                        <td>${response[i].verdiPapir}</td>
                        <td>${response[i].antall}</td>
                        <td>${response[i].belop}</td>
                        <td>${response[i].kurs}</td>
                        <td>${response[i].resultat}</td>
                        <td>${response[i].oppgjørsDag}</td>
                        <td>${response[i].transaksjonsType}</td>
                        <td>${response[i].comment}</td>
                        <th>
                    <input id=newComment${[i]}>
                    <button class="btn btn-primary" id=("commentButton") onclick="saveComment(${response[i].id},newComment${[i]}.value)">save comment</button>
                </th>
                <th>
                        <form id="form${[i]}" onsubmit="return false">
                          <select id="tagForm${[i]}" multiple name="id: ${response[i].id}">
                                <optgroup label="----TID PÅ DAGEN----">
                                <option value="tidlig">Tidlig</option>
                                <option value="midtPå">Midt på</option>
                                <option value="Sent">Sent</option>
                                </optgroup>
                                <optgroup label="----NYHETSPORTAL----">
                                <option value="e24">E24</option>
                                <option value="dn">DN</option>
                                <option value="finansavisen">Finansavisen</option>
                                </optgroup>
                          </select>
                          <input type="submit" value="Submit" onclick="handleSubmit(${[i]})">
                        </form>
                        </th>
                   </tr>`

    table.innerHTML +=row
}
}
let table = document.getElementById('myTable');

function saveComment(id,newComment){
    const Http = new XMLHttpRequest();
    
    let comment = newComment
    Http.open("PUT",urlU);
    Http.setRequestHeader("Content-Type","application/x-www-form-urlencoded;Charset=UTF-8")
    Http.setRequestHeader("Authorization", "Bearer " + localStorage.getItem("key"));
    Http.send("id="+id +"&&comment="+comment);
    Http.onreadystatechange = (event)=>{
        updateList();
    }


}

$("form").serializeArray()
function handleSubmit(i){


    let myForm = document.getElementById(`form${i}`)
    const formData = new FormData(myForm)
    let tags = []
    for(let pair of formData.entries()){
        let fields = pair[0].split(' ');
        let use = fields[1];
        
        
        tags = "{"+tags+"}"
        
        const Http = new XMLHttpRequest()
        Http.open("PUT",urlT);
        Http.setRequestHeader("Content-Type","application/x-www-form-urlencoded;Charset=UTF-8")
        Http.setRequestHeader("Authorization", "Bearer " + localStorage.getItem("key"));
        
        Http.send("id=" + use + "&&tag=" + pair[1]);

    }
}


$('#searchInput').on('keyup',function(){
    let value = $(this).val();
   
    let data = searchTable(value,response)
    createList(data);
})


function searchTable(value, data){
    let filteredData = [];
    for(let i=0; i < data.length; i++){
        value = value.toLowerCase();
        let verdiPapir = data[i].verdiPapir.toLowerCase();
        let transaksjon = data[i].transaksjonsType.toLowerCase();

        if(verdiPapir.includes(value) || transaksjon.includes(value)){
            filteredData.push(data[i])
        }


    }
    return filteredData;
}
//sort table by table header clicked
$('th').on('click',function () {

    let column = $(this).data('column')
    let order = $(this).data('order')
    


    if(order == 'desc'){
        $(this).data('order',"asc")
        response = response.sort((a,b) => a[column] > b[column] ? 1: -1)
        //text += '&#9660'
    }
    else{
        $(this).data('order',"desc")
        response = response.sort((a,b)=> a[column] < b[column] ? 1: -1)
        //text += '&#9650'
    }
    
    createList(response);
})