#@inproceedings{Barnes2019,
#    author = {Barnes, Jeremy and Touileb, Samia and {\O}vrelid, Lilja and Velldal, Erik},
#    title = {Lexicon information in neural sentiment analysis: a multi - task learning approach},
#    booktitle = "Proceedings of the 22nd Nordic Conference on Computational Linguistics",
#    month = "October",
#    year = "2019",
#    address = "Turku, Finland",
#    publisher = "Association for Computational Linguistics"
#}
def getData(sentiment):
    list = []
    if sentiment == "positive":
        lexicon = '/app/Fullform_Positive_lexicon.txt'
    elif sentiment == "negative":
        lexicon = '/app/Fullform_Negative_lexicon.txt'
    for word in open(lexicon, encoding="utf8"):
        list.append(word.rstrip("\n"))
    return list


def sentimentAnalysis(article):
    positiveLexicon = getData("positive")
    negativeLexicon = getData("negative")
    sentiment = 0
    positiveWords = []
    negativeWords = []
    articleWords = str.split(article)
    for words in articleWords:
        whitelist = set('abcdefghijklmnopqrstuvwxyzæøåABCDEFGHIJKLMNOPQRSTUVWXYZÆØÅ')
        cleanedWord = ''.join(filter(whitelist.__contains__, words))
        if cleanedWord.lower() in positiveLexicon:
            sentiment += 1
            positiveWords.append(cleanedWord)
        elif cleanedWord.lower() in negativeLexicon:
            sentiment -= 1
            negativeWords.append(cleanedWord)
        else:
            continue
    return sentiment, positiveWords, negativeWords
